
package JSON_Unpack;

import Credentials.UserCredentials;
import Files.WriteFile;
import HttpCall.HttpGet;
import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

///url/sensors/id/read

public class ReadSensors4Partner {
    public ArrayList<String> FetchSensor4Box(String companyName, String token) throws Exception {

        switch (companyName) {
            case "Germes":
                return SensorRead("Germes", token);
            case "Heufs":
                return SensorRead("Heufs", token);
            case "Jacobs":
                return SensorRead("Jacobs", token);
            case "Nica":
                return SensorRead("Nica", token);
        }
        return null;
    }

    protected ArrayList<String> SensorRead(String cName, String token) throws Exception {
        UserCredentials userCredentials = new UserCredentials();
        HttpGet httpCall = new HttpGet();
        WriteFile writingIntoFile = new WriteFile();

        String baseURL = userCredentials.getBaseURL();
        String homeRoot = UserCredentials.getHomeRoot();

        BoxCall4Partner boxCall4Partner = new BoxCall4Partner();
        String outputBox = boxCall4Partner.FetchBox(cName,token);
        String outputBoxFixed=outputBox.replace("[[","[") + outputBox.replace("]]","]");// To convert in Jsonarray we need to remove the array list brackets
        JSONArray jsonArray = new JSONArray(outputBoxFixed);
        System.out.println("FINAL WORKING ARRAY:"+jsonArray);
        ArrayList<String> list=new ArrayList<String>();
        int loopTerminator = 0;
        char par = '"';

            for(int j=0; j<jsonArray.length(); j++){
                JSONObject jsonobject = jsonArray.getJSONObject(j);
                String jsonID = jsonobject.getString("id");
                String jsonTag = jsonobject.getString("tag");
                String finalTag = ","+par+"sensorTag"+par+":"+jsonTag+"}]";

                String sensorOutput = httpCall.HttpGetCall(baseURL + "sensors/" + jsonID + "/read" + "?access_token=" + token, token);
                String modification = sensorOutput.replace("}]","");
                String finalSensorOutput = modification+finalTag;
                list.add(finalSensorOutput);

                writingIntoFile.WriteFile(homeRoot + jsonID + ".json", sensorOutput + jsonTag);
                loopTerminator++;
                if(loopTerminator == jsonArray.length()){
                    return list;
                }
            }


            return null;
    }


}
